package com.ether.dao;

import com.ether.PersistenceException;
import com.medias.database.objects.Parametre;
import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;

import java.util.List;

/**
 * @author vmipsl
 * @date 07 mar 2011
 */
public interface ParameterDAO
        extends DomainAccessObject<Parametre, Integer>
{
    @NotNull
    List<Parametre> getParametersByPlateformId( @NotNull final Integer plateformId )
            throws PersistenceException;

    @Nullable
    Parametre getParameterById( @NotNull final Integer parameterId )
            throws PersistenceException;

    @Nullable
    List<Parametre> getAllParametersOrderByCategoryByName()
            throws PersistenceException;

    @Nullable
    Integer getParameterByCode( @NotNull final String parameterCode )
            throws PersistenceException;
}