package com.ether;

import gov.noaa.pmel.sgt.JPane;
import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;

import java.awt.image.BufferedImage;
import java.util.Locale;

/**
 * @author vmipsl
 * @date 05 july 2011
 */
public interface EtherPlotService
        extends Service
{
    @NotNull
    public BufferedImage createMainPane( @NotNull final MegapoliPlot megapoliPlot, @Nullable final Locale locale )
            throws ServiceException;

    @NotNull
    public JPane createTopPane( @Nullable final MegapoliPlot megapoliPlot );

    @NotNull
    public JPane createBottomPane( @Nullable final Integer dataNumber, @Nullable final Integer realDataNumber, @Nullable final Locale locale );

    @NotNull
    public BufferedImage createErrorPane( @NotNull final String mainError, @Nullable final String errorText, @Nullable final Locale locale );

    @NotNull
    public JPane createEmptyCenterPane( @Nullable final Locale locale );

    @Nullable
    public <T extends MegapoliPlot> JPane createCenterPane( @NotNull final T megapoliPlot, @NotNull final Integer maxWidth, @NotNull final Integer maxHeight, @Nullable final Locale locale )
            throws ServiceException;

    @NotNull
    public JPane createTimeSeriePlot( @NotNull final VisualisationPlot megapoliPlot, @NotNull final Integer plotWidth, @NotNull final Integer plotHeight, @Nullable final Locale locale )
            throws ServiceException;

    @NotNull
    public JPane create2DPlot( @NotNull final VisualisationPlot megapoliPlot, @NotNull final Integer plotWidth, @NotNull final Integer plotHeight, @Nullable final Locale locale )
            throws ServiceException;

    @NotNull
    public JPane createSimulationPlot( @NotNull final SimulationPlot megapoliPlot, @NotNull final Integer plotWidth, @NotNull final Integer plotHeight, @Nullable final Locale locale )
            throws ServiceException;
}
